#include <iostream>
using namespace std;

int main() 
{
	long int n, k, i, l;
	long int br=0;
	cin>>n>>k;
	long int a[n];
	for(i=0; i<n; i++)
		cin>>a[i];
	long int b[2*n+1];
	for(i=0; i<2*n+1; i++)
		b[i]=0;
	for(i=0; i<n; i++)
	{
		if(a[i]<0)
			l=n-a[i];
		else
			l=a[i];
		b[l]++;
	}
	for(i=0; i<2*n+1; i++)
	{
		if(b[i]>=k)
			br++;
	}
	cout<<br<<"\n";
	for(i=0; i<2*n+1; i++)
	{
		if(b[i]>=k)
		{
			if(i>n)
				l=n-i;
			else
				l=i;
			cout<<l<<" ";
		}
	}
}